__ __ __ __ _____ _ _ _____ _ _ _ | \/ | \ \ / / | __ \ (_) | | / ____| | | | | | \ / |_ __\ V / | |__) | __ ___ ____ _| |_ ___ | (___ | |__ ___| | | | |\/| | '__|> < | ___/ '__| \ \ / / _` | __/ _ \ \___ \| '_ \ / _ \ | | | | | | |_ / . \ | | | | | |\ V / (_| | || __/ ____) | | | | __/ | | |_| |_|_(_)_/ \_\ |_| |_| |_| \_/ \__,_|\__\___| |_____/|_| |_|\___V 2.1 if you need WebShell for Seo everyday contact me on Telegram Telegram Address : @jackleetFor_More_Tools:
#!/bin/bash
# SPDX-License-Identifier: GPL-2.0
# This test sends one stream of traffic from H1 through a TBF shaper, to a RED
# within TBF shaper on $swp3. The two shapers have the same configuration, and
# thus the resulting stream should fill all available bandwidth on the latter
# shaper. A second stream is sent from H2 also via $swp3, and used to inject
# additional traffic. Since all available bandwidth is taken, this traffic has
# to go to backlog.
#
# +--------------------------+ +--------------------------+
# | H1 | | H2 |
# | + $h1 | | + $h2 |
# | | 192.0.2.1/28 | | | 192.0.2.2/28 |
# | | TBF 10Mbps | | | |
# +-----|--------------------+ +-----|--------------------+
# | |
# +-----|------------------------------------------------|--------------------+
# | SW | | |
# | +--|------------------------------------------------|----------------+ |
# | | + $swp1 + $swp2 | |
# | | BR | |
# | | | |
# | | + $swp3 | |
# | | | TBF 10Mbps / RED | |
# | +--------------------------------|-----------------------------------+ |
# | | |
# +-----------------------------------|---------------------------------------+
# |
# +-----|--------------------+
# | H3 | |
# | + $h1 |
# | 192.0.2.3/28 |
# | |
# +--------------------------+
ALL_TESTS="
ping_ipv4
ecn_test
ecn_nodrop_test
red_test
red_qevent_test
ecn_qevent_test
"
NUM_NETIFS=6
CHECK_TC="yes"
source lib.sh
BACKLOG=30000
PKTSZ=1400
h1_create()
{
simple_if_init $h1 192.0.2.1/28
defer simple_if_fini $h1 192.0.2.1/28
mtu_set $h1 10000
defer mtu_restore $h1
tc qdisc replace dev $h1 root handle 1: tbf \
rate 10Mbit burst 10K limit 1M
defer tc qdisc del dev $h1 root
}
h2_create()
{
simple_if_init $h2 192.0.2.2/28
defer simple_if_fini $h2 192.0.2.2/28
mtu_set $h2 10000
defer mtu_restore $h2
}
h3_create()
{
simple_if_init $h3 192.0.2.3/28
defer simple_if_fini $h3 192.0.2.3/28
mtu_set $h3 10000
defer mtu_restore $h3
}
switch_create()
{
ip link add dev br up type bridge
defer ip link del dev br
ip link set dev $swp1 up master br
defer ip link set dev $swp1 down nomaster
ip link set dev $swp2 up master br
defer ip link set dev $swp2 down nomaster
ip link set dev $swp3 up master br
defer ip link set dev $swp3 down nomaster
mtu_set $swp1 10000
defer mtu_restore $h1
mtu_set $swp2 10000
defer mtu_restore $h2
mtu_set $swp3 10000
defer mtu_restore $h3
tc qdisc replace dev $swp3 root handle 1: tbf \
rate 10Mbit burst 10K limit 1M
defer tc qdisc del dev $swp3 root
ip link add name _drop_test up type dummy
defer ip link del dev _drop_test
}
setup_prepare()
{
h1=${NETIFS[p1]}
swp1=${NETIFS[p2]}
h2=${NETIFS[p3]}
swp2=${NETIFS[p4]}
swp3=${NETIFS[p5]}
h3=${NETIFS[p6]}
h3_mac=$(mac_get $h3)
vrf_prepare
defer vrf_cleanup
h1_create
h2_create
h3_create
switch_create
}
ping_ipv4()
{
ping_test $h1 192.0.2.3 " from host 1"
ping_test $h2 192.0.2.3 " from host 2"
}
get_qdisc_backlog()
{
qdisc_stats_get $swp3 11: .backlog
}
get_nmarked()
{
qdisc_stats_get $swp3 11: .marked
}
get_qdisc_npackets()
{
qdisc_stats_get $swp3 11: .packets
}
get_nmirrored()
{
link_stats_get _drop_test tx packets
}
send_packets()
{
local proto=$1; shift
local pkts=$1; shift
$MZ $h2 -p $PKTSZ -a own -b $h3_mac -A 192.0.2.2 -B 192.0.2.3 -t $proto -q -c $pkts "$@"
}
# This sends traffic in an attempt to build a backlog of $size. Returns 0 on
# success. After 10 failed attempts it bails out and returns 1. It dumps the
# backlog size to stdout.
build_backlog()
{
local size=$1; shift
local proto=$1; shift
local i=0
while :; do
local cur=$(get_qdisc_backlog)
local diff=$((size - cur))
local pkts=$(((diff + PKTSZ - 1) / PKTSZ))
if ((cur >= size)); then
echo $cur
return 0
elif ((i++ > 10)); then
echo $cur
return 1
fi
send_packets $proto $pkts "$@"
sleep 1
done
}
check_marking()
{
local cond=$1; shift
local npackets_0=$(get_qdisc_npackets)
local nmarked_0=$(get_nmarked)
sleep 5
local npackets_1=$(get_qdisc_npackets)
local nmarked_1=$(get_nmarked)
local nmarked_d=$((nmarked_1 - nmarked_0))
local npackets_d=$((npackets_1 - npackets_0))
local pct=$((100 * nmarked_d / npackets_d))
echo $pct
((pct $cond))
}
check_mirroring()
{
local cond=$1; shift
local npackets_0=$(get_qdisc_npackets)
local nmirrored_0=$(get_nmirrored)
sleep 5
local npackets_1=$(get_qdisc_npackets)
local nmirrored_1=$(get_nmirrored)
local nmirrored_d=$((nmirrored_1 - nmirrored_0))
local npackets_d=$((npackets_1 - npackets_0))
local pct=$((100 * nmirrored_d / npackets_d))
echo $pct
((pct $cond))
}
ecn_test_common()
{
local name=$1; shift
local limit=$1; shift
local backlog
local pct
# Build the below-the-limit backlog using UDP. We could use TCP just
# fine, but this way we get a proof that UDP is accepted when queue
# length is below the limit. The main stream is using TCP, and if the
# limit is misconfigured, we would see this traffic being ECN marked.
RET=0
backlog=$(build_backlog $((2 * limit / 3)) udp)
check_err $? "Could not build the requested backlog"
pct=$(check_marking "== 0")
check_err $? "backlog $backlog / $limit Got $pct% marked packets, expected == 0."
log_test "$name backlog < limit"
# Now push TCP, because non-TCP traffic would be early-dropped after the
# backlog crosses the limit, and we want to make sure that the backlog
# is above the limit.
RET=0
backlog=$(build_backlog $((3 * limit / 2)) tcp tos=0x01)
check_err $? "Could not build the requested backlog"
pct=$(check_marking ">= 95")
check_err $? "backlog $backlog / $limit Got $pct% marked packets, expected >= 95."
log_test "$name backlog > limit"
}
do_ecn_test()
{
local limit=$1; shift
local name=ECN
$MZ $h1 -p $PKTSZ -A 192.0.2.1 -B 192.0.2.3 -c 0 \
-a own -b $h3_mac -t tcp -q tos=0x01 &
defer stop_traffic $!
sleep 1
ecn_test_common "$name" $limit
# Up there we saw that UDP gets accepted when backlog is below the
# limit. Now that it is above, it should all get dropped, and backlog
# building should fail.
RET=0
build_backlog $((2 * limit)) udp >/dev/null
check_fail $? "UDP traffic went into backlog instead of being early-dropped"
log_test "$name backlog > limit: UDP early-dropped"
}
do_ecn_nodrop_test()
{
local limit=$1; shift
local name="ECN nodrop"
$MZ $h1 -p $PKTSZ -A 192.0.2.1 -B 192.0.2.3 -c 0 \
-a own -b $h3_mac -t tcp -q tos=0x01 &
defer stop_traffic $!
sleep 1
ecn_test_common "$name" $limit
# Up there we saw that UDP gets accepted when backlog is below the
# limit. Now that it is above, in nodrop mode, make sure it goes to
# backlog as well.
RET=0
build_backlog $((2 * limit)) udp >/dev/null
check_err $? "UDP traffic was early-dropped instead of getting into backlog"
log_test "$name backlog > limit: UDP not dropped"
}
do_red_test()
{
local limit=$1; shift
local backlog
local pct
# Use ECN-capable TCP to verify there's no marking even though the queue
# is above limit.
$MZ $h1 -p $PKTSZ -A 192.0.2.1 -B 192.0.2.3 -c 0 \
-a own -b $h3_mac -t tcp -q tos=0x01 &
defer stop_traffic $!
# Pushing below the queue limit should work.
RET=0
backlog=$(build_backlog $((2 * limit / 3)) tcp tos=0x01)
check_err $? "Could not build the requested backlog"
pct=$(check_marking "== 0")
check_err $? "backlog $backlog / $limit Got $pct% marked packets, expected == 0."
log_test "RED backlog < limit"
# Pushing above should not.
RET=0
backlog=$(build_backlog $((3 * limit / 2)) tcp tos=0x01)
check_fail $? "Traffic went into backlog instead of being early-dropped"
pct=$(check_marking "== 0")
check_err $? "backlog $backlog / $limit Got $pct% marked packets, expected == 0."
log_test "RED backlog > limit"
}
do_red_qevent_test()
{
local limit=$1; shift
local backlog
local base
local now
local pct
RET=0
$MZ $h1 -p $PKTSZ -A 192.0.2.1 -B 192.0.2.3 -c 0 \
-a own -b $h3_mac -t udp -q &
defer stop_traffic $!
sleep 1
tc filter add block 10 pref 1234 handle 102 matchall skip_hw \
action mirred egress mirror dev _drop_test
# Push to the queue until it's at the limit. The configured limit is
# rounded by the qdisc, so this is the best we can do to get to the real
# limit.
build_backlog $((3 * limit / 2)) udp >/dev/null
base=$(get_nmirrored)
send_packets udp 100
sleep 1
now=$(get_nmirrored)
((now >= base + 100))
check_err $? "Dropped packets not observed: 100 expected, $((now - base)) seen"
tc filter del block 10 pref 1234 handle 102 matchall
base=$(get_nmirrored)
send_packets udp 100
sleep 1
now=$(get_nmirrored)
((now == base))
check_err $? "Dropped packets still observed: 0 expected, $((now - base)) seen"
log_test "RED early_dropped packets mirrored"
}
do_ecn_qevent_test()
{
local limit=$1; shift
local name=ECN
RET=0
$MZ $h1 -p $PKTSZ -A 192.0.2.1 -B 192.0.2.3 -c 0 \
-a own -b $h3_mac -t tcp -q tos=0x01 &
defer stop_traffic $!
sleep 1
tc filter add block 10 pref 1234 handle 102 matchall skip_hw \
action mirred egress mirror dev _drop_test
backlog=$(build_backlog $((2 * limit / 3)) tcp tos=0x01)
check_err $? "Could not build the requested backlog"
pct=$(check_mirroring "== 0")
check_err $? "backlog $backlog / $limit Got $pct% mirrored packets, expected == 0."
backlog=$(build_backlog $((3 * limit / 2)) tcp tos=0x01)
check_err $? "Could not build the requested backlog"
pct=$(check_mirroring ">= 95")
check_err $? "backlog $backlog / $limit Got $pct% mirrored packets, expected >= 95."
tc filter del block 10 pref 1234 handle 102 matchall
log_test "ECN marked packets mirrored"
}
install_qdisc()
{
local -a args=("$@")
tc qdisc replace dev $swp3 parent 1:1 handle 11: red \
limit 1M avpkt $PKTSZ probability 1 \
min $BACKLOG max $((BACKLOG + 1)) burst 38 "${args[@]}"
sleep 1
}
uninstall_qdisc()
{
tc qdisc del dev $swp3 parent 1:1
}
ecn_test()
{
install_qdisc ecn
defer uninstall_qdisc
xfail_on_slow do_ecn_test $BACKLOG
}
ecn_nodrop_test()
{
install_qdisc ecn nodrop
defer uninstall_qdisc
xfail_on_slow do_ecn_nodrop_test $BACKLOG
}
red_test()
{
install_qdisc
defer uninstall_qdisc
xfail_on_slow do_red_test $BACKLOG
}
red_qevent_test()
{
install_qdisc qevent early_drop block 10
defer uninstall_qdisc
xfail_on_slow do_red_qevent_test $BACKLOG
}
ecn_qevent_test()
{
install_qdisc ecn qevent mark block 10
defer uninstall_qdisc
xfail_on_slow do_ecn_qevent_test $BACKLOG
}
trap cleanup EXIT
setup_prepare
setup_wait
tests_run
exit $EXIT_STATUS
| Name | Type | Size | Permission | Actions |
|---|---|---|---|---|
| Makefile | File | 2.94 KB | 0644 |
|
| bridge_fdb_learning_limit.sh | File | 5.8 KB | 0755 |
|
| bridge_igmp.sh | File | 14.71 KB | 0755 |
|
| bridge_locked_port.sh | File | 9.25 KB | 0755 |
|
| bridge_mdb.sh | File | 45.15 KB | 0755 |
|
| bridge_mdb_host.sh | File | 1.66 KB | 0755 |
|
| bridge_mdb_max.sh | File | 29.98 KB | 0755 |
|
| bridge_mdb_port_down.sh | File | 2.24 KB | 0755 |
|
| bridge_mld.sh | File | 16.17 KB | 0755 |
|
| bridge_port_isolation.sh | File | 2.32 KB | 0755 |
|
| bridge_sticky_fdb.sh | File | 1.13 KB | 0755 |
|
| bridge_vlan_aware.sh | File | 4.2 KB | 0755 |
|
| bridge_vlan_mcast.sh | File | 16.74 KB | 0755 |
|
| bridge_vlan_unaware.sh | File | 1.65 KB | 0755 |
|
| custom_multipath_hash.sh | File | 9.8 KB | 0755 |
|
| devlink_lib.sh | File | 12.81 KB | 0644 |
|
| dual_vxlan_bridge.sh | File | 11.21 KB | 0755 |
|
| fib_offload_lib.sh | File | 24.57 KB | 0644 |
|
| gre_custom_multipath_hash.sh | File | 12.51 KB | 0755 |
|
| gre_inner_v4_multipath.sh | File | 7.55 KB | 0755 |
|
| gre_inner_v6_multipath.sh | File | 7.66 KB | 0755 |
|
| gre_multipath.sh | File | 6.29 KB | 0755 |
|
| gre_multipath_nh.sh | File | 8.1 KB | 0755 |
|
| gre_multipath_nh_res.sh | File | 8.25 KB | 0755 |
|
| ip6_forward_instats_vrf.sh | File | 3.04 KB | 0755 |
|
| ip6gre_custom_multipath_hash.sh | File | 12.77 KB | 0755 |
|
| ip6gre_flat.sh | File | 1.18 KB | 0755 |
|
| ip6gre_flat_key.sh | File | 1.24 KB | 0755 |
|
| ip6gre_flat_keys.sh | File | 1.3 KB | 0755 |
|
| ip6gre_hier.sh | File | 1.27 KB | 0755 |
|
| ip6gre_hier_key.sh | File | 1.33 KB | 0755 |
|
| ip6gre_hier_keys.sh | File | 1.39 KB | 0755 |
|
| ip6gre_inner_v4_multipath.sh | File | 7.77 KB | 0755 |
|
| ip6gre_inner_v6_multipath.sh | File | 7.88 KB | 0755 |
|
| ip6gre_lib.sh | File | 15.75 KB | 0644 |
|
| ipip_flat_gre.sh | File | 838 B | 0755 |
|
| ipip_flat_gre_key.sh | File | 860 B | 0755 |
|
| ipip_flat_gre_keys.sh | File | 886 B | 0755 |
|
| ipip_hier_gre.sh | File | 887 B | 0755 |
|
| ipip_hier_gre_key.sh | File | 910 B | 0755 |
|
| ipip_hier_gre_keys.sh | File | 938 B | 0755 |
|
| ipip_lib.sh | File | 8.34 KB | 0644 |
|
| lib.sh | File | 41.63 KB | 0644 |
|
| lib_sh_test.sh | File | 3.57 KB | 0755 |
|
| local_termination.sh | File | 14.42 KB | 0755 |
|
| min_max_mtu.sh | File | 4.74 KB | 0755 |
|
| mirror_gre.sh | File | 2.9 KB | 0755 |
|
| mirror_gre_bound.sh | File | 5.51 KB | 0755 |
|
| mirror_gre_bridge_1d.sh | File | 4.12 KB | 0755 |
|
| mirror_gre_bridge_1d_vlan.sh | File | 2.37 KB | 0755 |
|
| mirror_gre_bridge_1q.sh | File | 3.97 KB | 0755 |
|
| mirror_gre_bridge_1q_lag.sh | File | 7.02 KB | 0755 |
|
| mirror_gre_changes.sh | File | 5.17 KB | 0755 |
|
| mirror_gre_flower.sh | File | 2.61 KB | 0755 |
|
| mirror_gre_lag_lacp.sh | File | 7.48 KB | 0755 |
|
| mirror_gre_lib.sh | File | 3.65 KB | 0644 |
|
| mirror_gre_neigh.sh | File | 2.08 KB | 0755 |
|
| mirror_gre_nh.sh | File | 2.53 KB | 0755 |
|
| mirror_gre_topo_lib.sh | File | 3.45 KB | 0644 |
|
| mirror_gre_vlan.sh | File | 1.36 KB | 0755 |
|
| mirror_gre_vlan_bridge_1q.sh | File | 8.46 KB | 0755 |
|
| mirror_lib.sh | File | 3.72 KB | 0644 |
|
| mirror_topo_lib.sh | File | 2.73 KB | 0644 |
|
| mirror_vlan.sh | File | 1.86 KB | 0755 |
|
| no_forwarding.sh | File | 5.52 KB | 0755 |
|
| pedit_dsfield.sh | File | 6.69 KB | 0755 |
|
| pedit_ip.sh | File | 4.41 KB | 0755 |
|
| pedit_l4port.sh | File | 4.46 KB | 0755 |
|
| q_in_vni.sh | File | 10.71 KB | 0755 |
|
| q_in_vni_ipv6.sh | File | 10.87 KB | 0755 |
|
| router.sh | File | 7.32 KB | 0755 |
|
| router_bridge.sh | File | 3.97 KB | 0755 |
|
| router_bridge_1d.sh | File | 5.1 KB | 0755 |
|
| router_bridge_1d_lag.sh | File | 9.3 KB | 0755 |
|
| router_bridge_lag.sh | File | 6.82 KB | 0755 |
|
| router_bridge_pvid_vlan_upper.sh | File | 3.5 KB | 0755 |
|
| router_bridge_vlan.sh | File | 5.46 KB | 0755 |
|
| router_bridge_vlan_upper.sh | File | 3.92 KB | 0755 |
|
| router_bridge_vlan_upper_pvid.sh | File | 3.7 KB | 0755 |
|
| router_broadcast.sh | File | 5.02 KB | 0755 |
|
| router_mpath_nh.sh | File | 10.73 KB | 0755 |
|
| router_mpath_nh_lib.sh | File | 3.2 KB | 0644 |
|
| router_mpath_nh_res.sh | File | 12.71 KB | 0755 |
|
| router_mpath_seed.sh | File | 7.37 KB | 0755 |
|
| router_multicast.sh | File | 14.6 KB | 0755 |
|
| router_multipath.sh | File | 7.07 KB | 0755 |
|
| router_nh.sh | File | 3.31 KB | 0755 |
|
| router_vid_1.sh | File | 3.52 KB | 0755 |
|
| sch_ets.sh | File | 745 B | 0755 |
|
| sch_ets_core.sh | File | 7.33 KB | 0644 |
|
| sch_ets_tests.sh | File | 4.09 KB | 0644 |
|
| sch_red.sh | File | 11.14 KB | 0755 |
|
| sch_tbf_core.sh | File | 4.77 KB | 0644 |
|
| sch_tbf_ets.sh | File | 118 B | 0755 |
|
| sch_tbf_etsprio.sh | File | 1.37 KB | 0644 |
|
| sch_tbf_prio.sh | File | 118 B | 0755 |
|
| sch_tbf_root.sh | File | 496 B | 0755 |
|
| skbedit_priority.sh | File | 3.87 KB | 0755 |
|
| tc_actions.sh | File | 9.3 KB | 0755 |
|
| tc_chains.sh | File | 4.83 KB | 0755 |
|
| tc_common.sh | File | 710 B | 0644 |
|
| tc_flower.sh | File | 21.24 KB | 0755 |
|
| tc_flower_cfm.sh | File | 4.85 KB | 0755 |
|
| tc_flower_l2_miss.sh | File | 9.13 KB | 0755 |
|
| tc_flower_port_range.sh | File | 7.35 KB | 0755 |
|
| tc_flower_router.sh | File | 3.02 KB | 0755 |
|
| tc_mpls_l2vpn.sh | File | 5.03 KB | 0755 |
|
| tc_police.sh | File | 11.75 KB | 0755 |
|
| tc_shblocks.sh | File | 2.68 KB | 0755 |
|
| tc_tunnel_key.sh | File | 3.71 KB | 0755 |
|
| tc_vlan_modify.sh | File | 3.17 KB | 0755 |
|
| tsn_lib.sh | File | 5.47 KB | 0644 |
|
| vxlan_asymmetric.sh | File | 17.55 KB | 0755 |
|
| vxlan_asymmetric_ipv6.sh | File | 16.03 KB | 0755 |
|
| vxlan_bridge_1d.sh | File | 20.4 KB | 0755 |
|
| vxlan_bridge_1d_ipv6.sh | File | 21.31 KB | 0755 |
|
| vxlan_bridge_1d_port_8472.sh | File | 172 B | 0755 |
|
| vxlan_bridge_1d_port_8472_ipv6.sh | File | 188 B | 0755 |
|
| vxlan_bridge_1q.sh | File | 22.91 KB | 0755 |
|
| vxlan_bridge_1q_ipv6.sh | File | 24.35 KB | 0755 |
|
| vxlan_bridge_1q_port_8472.sh | File | 172 B | 0755 |
|
| vxlan_bridge_1q_port_8472_ipv6.sh | File | 188 B | 0755 |
|
| vxlan_reserved.sh | File | 7.23 KB | 0755 |
|
| vxlan_symmetric.sh | File | 18.05 KB | 0755 |
|
| vxlan_symmetric_ipv6.sh | File | 18.31 KB | 0755 |
|